#pragma once

#include "DialogManager.h"
#include "NoteModel.h"
#include "NoteMemberInfoActorEvent.h"

class CMemoSendDlg;
class CMemoAuthorize;
class CCreateSendNoteDlgThread;
class CNoteMemberInfoActorEvent;

class SendNoteMananger : public DialogManager,
	private IGTWASActorEvent
{
public:
	SendNoteMananger(unsigned int nCapaOfSendDlgPool);
	~SendNoteMananger(void);

	void WasRegister() 
	{
		g_pMessengerActor->GetWASActor()->RegisterObserver(this);
	}

	void CreateSingleBuddyNote(const IGTBuddyUser* pUser);
	void CreateMemberListNote(const NE_MEMBER_DATA_LIST& list);
	void CreateReceiverInfoListNote(const std::vector<ReceiverInfo>& receiverVector);
	void CreateBuddyListNote(const std::vector<const IGTBuddyUser*>& buddyVector);
	void CreateListNote( const std::vector<ReceiverInfo>& vecReceiver );

	void CreateFileSendNote(const std::vector<AttachFileInfo>& fileInfoVector, const std::vector<ReceiverInfo>& receiverVector);

	void MakeMemoSendDlg( std::vector<ReceiverInfo> &receiverVector );
	void MakeMemoSendDlg( CString strWriteModeParam, ULONGLONG lNoteNum, CWnd* pCreationDlg = NULL);

	void MakeMemoSendDlg(const std::vector<ReceiverInfo> receiverVector, CString strTitle, CString strContent);
	void PreMakeMemoSendDlg(const std::vector<ReceiverInfo> receiverVector, CString strTitle, CString strContent);

	void SetReceiverMaxCount(int nCount);
	void SetAuthorize(DWORD dwAuth);
	DWORD GetAuthorize();
	void SetCurrentFileSize(ULONGLONG ullSize);
	ULONGLONG GetCurrentFileSize();

	void InitSendNoteDialogPool();
	void CreateSendNoteDlg(CCreateSendNoteDlgThread *pCreateSendDlgThread);
	void StuffSendNoteDialogPool();
	void ClearSendNoteDialogPool();
	void SetViewLanguagePack();

	virtual void Remove(CDialog* pDialog);
	virtual int RemoveAll();
	CNoteMemberInfoActorEvent* m_pSendNoteMemberInfoActorEvent;

	void RecvMemoDlgIsClosed(CDialog* pDialog);

protected:
	virtual bool		OnGTWASActor_ResponseGetAttachID(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, LPCSTR szAttachID);
	virtual bool		OnGTWASActor_ResponseGetReplyBody(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, NoteReplyBody &replyBodyInfo);
	virtual bool		OnGTWASActor_ResponseSendNote(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode nWasErrorCode, int nJsonErrorCode, LPCWSTR strResponseMsg);

private:
	virtual void SetReadOnly(BOOL bStatus, CObject* pObject);

	void Create(const std::vector<ReceiverInfo>& receiverVector );

	void Create(const std::vector<AttachFileInfo>& fileInfoVector, const std::vector<ReceiverInfo>& receiverVector);

	unsigned int m_nReceiverMaxCount;

	CMemoAuthorize* m_pMemoAuthorize;


	//vector<CMemoSendDlg*> m_listSendDialogPool;

	unsigned int m_nCapaOfSendDlgPool;
	CMemoSendDlg* GetMemoSendDlgFromPool();
	
	CCriticalSection m_csCreateMemoSendDlgThread;
};


class CCreateSendNoteDlgThread : public CWinThread
{
	DECLARE_DYNCREATE(CCreateSendNoteDlgThread)

public:
	void SetDlgManager(SendNoteMananger *pDlgManager);

	virtual int Run();
	virtual BOOL InitInstance();

	//afx_msg void OnCreateAndStuffSendNoteDialog(WPARAM wParam, LPARAM lParam);

protected:
	DECLARE_MESSAGE_MAP()

public:
	CCreateSendNoteDlgThread();           //  ⿡ Ǵ protected Դϴ.
	virtual ~CCreateSendNoteDlgThread();

private:
	SendNoteMananger	*m_pDlgManager;
};

